using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace Components
{
    // PropertyAttributeEventAttributeֱPropertyEventϣ[]
    // DefaultPropertyAttributeDefaultEventAttributeͷϡ
    [DefaultEvent("CustomerLogout")]  
    public class Customer : Component
    {
        private string _id;
        private string _sex;
        private int _age;
        private string _address;
        private DateTime _createTime;

        // ûCategoryAttributeDescriptionAttribute
        public string Id
        {
            get { return _id; }
            set { _id = value; }
        }

        // Customer's DetailsУCategoryAttributeDescriptionAttributeҲEvent
        [Category("Customer's Details"), Description("Customer's Sex")]  // һ[]дAttribute
        public string Sex
        {
            get { return _sex; }
            set { _sex = value; }
        }

        [Category("Customer's Details")]
        [Description("Customer's Age"), DefaultValue(20)]
        public int Age
        {
            get { return _age; }
            set { _age = value; }
        }

        [DefaultValue("shanghai"),Category("Customer's Details")]
        public string Address
        {
            get { return _address; }
            set { _address = value; }
        }

        [Browsable(false)] // PropertyPropertyвɼBrowsableAttributeҲEvent
        public DateTime CreateTime
        {
            get { return _createTime; }
            set { _createTime = value; }
        }



        public sealed class CustomerLoginEventArgs : EventArgs
        { }
        public sealed class CustomerLogoutEventArgs : EventArgs
        { }

        public delegate void CustomerLoginEventHandler(object sender, CustomerLoginEventArgs e);
        public delegate void CustomerLogoutEventHandler(object sender, CustomerLogoutEventArgs e);

        public event CustomerLoginEventHandler CustomerLogin
        {
            add { }
            remove { }
        }

        public event CustomerLogoutEventHandler CustomerLogout
        {
            add { }
            remove { }
        }
    }
}
