using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Drawing;
using System.Drawing.Design;
using System.Windows.Forms;
using System.Windows.Forms.Design;

namespace Components
{
    // õvs 2005List<>vs 2003ԼȥʵStudentCollection
    // ֻҪPropertyΪ̳IListͣProperty Designer UIvsԴġ
    public class Demo3 : Component
    {
        public Demo3()
        {
            _students = new List<Student>(); // һҪڹ캯ʵ_students
        }

        private List<Student> _students;
        private string _grade;

        // vs ԴDesigner
        // ûDesignerSerializationVisibilityAttributeĻStudentsֵֵܱ档
        // ҿ԰DesignerSerializationVisibilityAttributeע͵Studentsֵ󣬹رvs´Ŀ۲Studentsֵûб
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
        public List<Student> Students
        {
            get { return _students; }
            set { _students = value; }
        }

        // ûԶDesigner
        [Editor(typeof(GradeEditor), typeof(UITypeEditor)), LocalizableAttribute(true)]
        public string Grade
        {
            get { return _grade; }
            set { _grade = value; }
        }
    }

    public class Student
    {
        private int _id;
        private string _name;

        public int Id
        {
            get { return _id; }
            set { _id = value; }
        }

        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }
    }

    public class StudentCollection : CollectionBase
    {
       
    }

    public class GradeEditor : UITypeEditor
    {
        [System.Security.Permissions.PermissionSet(System.Security.Permissions.SecurityAction.Demand)]
        public override System.Drawing.Design.UITypeEditorEditStyle GetEditStyle(System.ComponentModel.ITypeDescriptorContext context)
        {
            // UITypeEditorEditStyle֣ModalǵʽDropDownʽNoneûС
            return UITypeEditorEditStyle.Modal;
        }

        [System.Security.Permissions.PermissionSet(System.Security.Permissions.SecurityAction.Demand)]
        public override object EditValue(System.ComponentModel.ITypeDescriptorContext context, System.IServiceProvider provider, object value)
        {
            // õeditor service䴴ڡ
            IWindowsFormsEditorService editorService = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));

            // context.Instance  ԵõǰDemo3
            // ((Demo3)context.Instance).Grade  ԵõǰGradeֵ

            frmGradeEditor dialog = new frmGradeEditor();
            editorService.ShowDialog(dialog);
            String grade = dialog.Grade;
            dialog.Dispose();
            
            return grade;
        }
    }
}
